#!/usr/bin/env python3

import colorsys
from math import isclose

def chk(fun1, fun2, r, g, b):
	other = fun1(r,g,b)
	r2, g2, b2 = fun2(*list(other))
	if not isclose(r, r2, abs_tol=0.0001) \
	or not isclose(g, g2, abs_tol=0.0001) \
	or not isclose(b, b2, abs_tol=0.0001):
		raise Exception('after {}, rgb {},{},{} became {},{},{}'.format(
			fun1, r, g, b, r2, g2, b2))

for r in range(301):
	print('testing r={}'.format(r))
	for g in range(301):
		#print('testing r={}, g={}'.format(r, g))
		for b in range(301):
			chk(colorsys.rgb_to_yiq, colorsys.yiq_to_rgb, r/300, g/300, b/300)
			chk(colorsys.rgb_to_hls, colorsys.hls_to_rgb, r/300, g/300, b/300)
			chk(colorsys.rgb_to_hsv, colorsys.hsv_to_rgb, r/300, g/300, b/300)

print('nice')
